// Package v1beta1 provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/oapi-codegen/oapi-codegen/v2 version v2.3.0 DO NOT EDIT.
package v1beta1

import (
	"github.com/gofrs/uuid"
	externalRef2 "github.com/meshery/schemas/models/core"
)

// Environment defines model for environment.
type Environment struct {
	ID        externalRef2.EnvironmentId `db:"id" json:"id"`
	CreatedAt externalRef2.Time          `json:"created_at,omitempty"`

	// DeletedAt SQL null Timestamp to handle null values of time.
	DeletedAt      externalRef2.NullTime       `json:"deleted_at,omitempty"`
	Description    externalRef2.Text           `json:"description,omitempty"`
	Name           externalRef2.Text           `json:"name,omitempty"`
	OrganizationId externalRef2.OrganizationId `db:"org_id" json:"org_id"`
	Owner          externalRef2.Text           `json:"owner,omitempty"`
	UpdatedAt      externalRef2.Time           `json:"updated_at,omitempty"`
}

// EnvironmentConnectionMapping defines model for environmentConnectionMapping.
type EnvironmentConnectionMapping struct {
	ID           externalRef2.EnvironmentId `db:"id" json:"id"`
	ConnectionId uuid.UUID                  `db:"connection_id" json:"connection_id"`
	CreatedAt    externalRef2.Time          `json:"created_at,omitempty"`

	// DeletedAt SQL null Timestamp to handle null values of time.
	DeletedAt     externalRef2.NullTime `json:"deleted_at,omitempty"`
	EnvironmentId uuid.UUID             `db:"environment_id" json:"environment_id"`
	UpdatedAt     externalRef2.Time     `json:"updated_at,omitempty"`
}

// EnvironmentPage defines model for environmentPage.
type EnvironmentPage struct {
	Environments []Environment       `json:"environments,omitempty"`
	Page         externalRef2.Number `json:"page,omitempty"`
	PageSize     externalRef2.Number `json:"page_size,omitempty"`
	TotalCount   externalRef2.Number `json:"total_count,omitempty"`
}

// EnvironmentPayload defines model for environmentPayload.
type EnvironmentPayload struct {
	// OrgId Organization ID
	OrgId       string            `json:"organization_id"`
	Description externalRef2.Text `json:"description,omitempty"`
	Name        externalRef2.Text `json:"name"`
}
